/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup RCC
  * @{
  */

/**
  * @addtogroup RCC_SysclkConfig
  * @{
  */

/* Private typedef --------------------------------------------------------------*/

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/

/* Private functions ------------------------------------------------------------*/
void SYSCLK_HSI_Config(void);
void SYSCLK_PLL_Config(void);
void LSI_Config(void);
void LSE_Config(void);

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  /* Configure the system clock */
  SystemClockInit();
  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);

  /* Print Uart Init */
  EVAL_ComInit();

  /********************* Operation  *********************/
  /* Switching HSI for system clock */
  SYSCLK_HSI_Config();
  printf("SYSCLK: HSI\n");

  /* Switching LSI for LSCLK */
  LSI_Config();
  printf("LSCLK: LSI\n");

  /* Switching PLL for system clock */
  SYSCLK_PLL_Config();
  printf("SYSCLK: PLL\n");
  
  /* Switching LSE for LSCLK */
  LSE_Config();
  printf("LSCLK: LSE\n");

  uint32_t ledTime = 0;
  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }
  }
}

/**
 *******************************************************************************
 * @brief   Switching HSI for System Clock initialization.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void SYSCLK_HSI_Config(void)
{
  RCC_Unlock();
  
  RCC_ClkInitTypeStruct RCC_ClkInitStruct;
  RCC_ClockStructInit(&RCC_ClkInitStruct);
  /* Clock type configured */
  RCC_ClkInitStruct.RCC_ClockType = (uint32_t)(RCC_CLOCK_TYPE_SYSCLK |RCC_CLOCK_TYPE_HCLK);
  /* Congfig SYSCLK clock source */
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLK_SOURCE_HSI;
  /* Congfig HCLK clock source */
  RCC_ClkInitStruct.HCLKDivider = RCC_SYSCLK_DIV1;
  /* Congfig PCLK clock source */
  RCC_ClkInitStruct.PCLKDivider = RCC_HCLK_DIV1;
  RCC_ClockConfig(&RCC_ClkInitStruct);                                                                            

  RCC_Lock();
}
/**
 *******************************************************************************
 * @brief   Switching PLL for System Clock initialization.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void SYSCLK_PLL_Config(void)
{
  RCC_Unlock();

  /* Configure phase-locked loop */
  RCC_OscInitTypeStruct RCC_OscInitStruct;
  RCC_OscStructInit(&RCC_OscInitStruct);
  RCC_OscInitStruct.RCC_PLL.PLLSource = RCC_PLL_SOURCE_HSI_DIV8;
  RCC_OscInitStruct.RCC_PLL.PLLMUL = RCC_PLL_MUL8;
  RCC_OscInitStruct.RCC_PLL.PLLState = RCC_PLL_ON;
  RCC_OscConfig(&RCC_OscInitStruct);
  
  RCC_ClkInitTypeStruct RCC_ClkInitStruct;
  RCC_ClockStructInit(&RCC_ClkInitStruct);
  /* Clock type configured */
  RCC_ClkInitStruct.RCC_ClockType = (uint32_t)(RCC_CLOCK_TYPE_SYSCLK |RCC_CLOCK_TYPE_HCLK | RCC_CLOCK_TYPE_PCLK);
  /* Congfig SYSCLK clock source */
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLK_SOURCE_PLL;
  /* Congfig HCLK clock source */
  RCC_ClkInitStruct.HCLKDivider = RCC_SYSCLK_DIV1;
  /* Congfig PCLK clock source */
  RCC_ClkInitStruct.PCLKDivider = RCC_HCLK_DIV1;
  RCC_ClockConfig(&RCC_ClkInitStruct);

  RCC_Lock();
}
/**
 *******************************************************************************
 * @brief   Switching LSI for LSCLK initialization.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void LSI_Config(void)
{
  /* Enable LSI */
  RCC_Unlock();
  RCC_OscInitTypeStruct RCC_OscInitStruct;
  RCC_OscStructInit(&RCC_OscInitStruct);
  RCC_OscInitStruct.RCC_OscillatorType = RCC_OSCILLATOR_TYPE_LSI;
  RCC_OscInitStruct.RCC_LSIState = RCC_LSI_ON;
  RCC_OscConfig(&RCC_OscInitStruct);
  
  RCC_ClkInitTypeStruct RCC_ClkInitStruct;
  RCC_ClockStructInit(&RCC_ClkInitStruct);
  RCC_ClkInitStruct.RCC_ClockType = RCC_CLOCK_TYPE_LSCLK;
  RCC_ClkInitStruct.LSCLKSource = RCC_LSCLK_SOURCE_LSI;
  RCC_ClockConfig(&RCC_ClkInitStruct);
  RCC_Lock();
}
/**
 *******************************************************************************
 * @brief   Switching LSE for LSCLK initialization.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void LSE_Config(void)
{
  /* Enable LSI */
  RCC_Unlock();
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  /* Config LSE output GPIO */
  GPIO_InitTypeStruct GPIO_InitStruct;
  GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ANALOG;
  GPIO_InitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  GPIO_InitStruct.GPIO_OType = GPIO_OTYPE_PP;
  GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  GPIO_InitStruct.GPIO_Pin = GPIO_PIN_14|GPIO_PIN_15;
  GPIO_Init(GPIOC, &GPIO_InitStruct);
 
  /* Enable LSE */
  RCC_OscInitTypeStruct RCC_OscInitStruct;
  RCC_OscStructInit(&RCC_OscInitStruct);
  RCC_OscInitStruct.RCC_OscillatorType = RCC_OSCILLATOR_TYPE_LSE ;
  RCC_OscInitStruct.RCC_LSEState = RCC_LSE_ON;
  RCC_OscConfig(&RCC_OscInitStruct);
  
  RCC_ClkInitTypeStruct RCC_ClkInitStruct;
  RCC_ClockStructInit(&RCC_ClkInitStruct);
  RCC_ClkInitStruct.RCC_ClockType = RCC_CLOCK_TYPE_LSCLK;
  RCC_ClkInitStruct.LSCLKSource = RCC_LSCLK_SOURCE_LSE;
  RCC_ClockConfig(&RCC_ClkInitStruct);
  RCC_Lock();
}

/* retarget the C library printf function to the usart */
int fputc(int ch, FILE *f)
{
  UART_SendData(EVAL_COM0, (uint8_t)ch);

  while(RESET == UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE));

  return ch;
}



/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
